/*
 * Written by Oron Peled <oron@actcom.co.il>
 *
 * Some code snippets adapted from spak
 * (http://www.xenos.net/software/spak/)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/ethernet.h>
#include <net/if.h>
#include "config.h"
#include "linkloop.h"

static char	*program = NULL;

static char	*iface = "eth0";
u_int8_t	mac_src[IFHWADDRLEN];
u_int8_t	mac_dst[IFHWADDRLEN];

int main(int argc, char *argv[]) {
	int sock;
	struct llc_packet spack;
	struct llc_packet rpack;

	program = argv[0];

	/* Open a socket */
	if ((sock = socket(AF_INET, SOCK_PACKET, htons(ETH_P_802_2))) == -1) {
		perror("socket");
		return 1;
	}
	get_hwaddr(sock, iface, mac_src);

	do {
		printf ("Waiting for Test packets on %s (HW addr %s)\n", iface, mac2str(mac_src));

		recv_packet(sock, &rpack);
		memcpy(mac_dst, rpack.eth_hdr.ether_shost, IFHWADDRLEN);
		mk_test_packet(&spack, mac_src, mac_dst, 1);

		send_packet(sock, iface, &spack);
	} while(1);
	return 0;
}
